
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Struts 拦截器权限控制【通过拦截器实现登录后跳转到登录前页面】 / iVAN</title>

    <meta name="description" content="Struts 拦截器权限控制【通过拦截器实现登录后跳转到登录前页面】 应用情形:在web项目中,经常会遇到用户未登录或SESSION失效时用户发出非法的权限操作,如新闻的评论.文件的下载等等,在此我们可以使用struts拦截器对该用户发出的请求进行拦截,拦截后判断用户是否登录或SESSION是否有效,然后进行其正常操作.具体实例如下: 新建一个拦截器类UserInterceptor ,UserInterceptor.java代码如下 [java] view plaincopyprint? package com.hsinghsu.test.interceptor;">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Struts 拦截器权限控制【通过拦截器实现登录后跳转到登录前页面】</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>应用情形：在web项目中，经常会遇到用户未登录或SESSION失效时用户发出非法的权限操作，如新闻的评论、文件的下载等等，在此我们可以使用struts拦截器对该用户发出的请求进行拦截，拦截后判断用户是否登录或SESSION是否有效，然后进行其正常操作。具体实例如下：</p>
<p>新建一个拦截器类UserInterceptor ，UserInterceptor.java代码如下</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>package com.hsinghsu.test.interceptor;  </li>
<li>  </li>
<li>import com.opensymphony.xwork2.*;  </li>
<li>import com.opensymphony.xwork2.interceptor.AbstractInterceptor;  </li>
<li>import java.util.*;  </li>
<li>import javax.servlet.http.HttpServletRequest;  </li>
<li>import org.apache.struts2.ServletActionContext;  </li>
<li>  </li>
<li>public class UserInterceptor extends AbstractInterceptor {  </li>
<li>  </li>
<li>    private static final long serialVersionUID = 4956767125951165062L;  </li>
<li>  </li>
<li>    // 拦截Action处理的拦截方法  </li>
<li>    public String intercept(ActionInvocation invocation) throws Exception {  </li>
<li>  </li>
<li>        // 取得请求相关的ActionContext实例  </li>
<li>        ActionContext ctx = invocation.getInvocationContext();  </li>
<li>        Map&lt;String, Object&gt; session = ctx.getSession();  </li>
<li>        // 取出名为user的Session属性  </li>
<li>        String user = (String) session.get("user");  </li>
<li>  </li>
<li>        // 如果已经登录，放行  </li>
<li>        if (user != null &amp;&amp; user.equals("hsing")) {  </li>
<li>            return invocation.invoke();  </li>
<li>        }  </li>
<li>  </li>
<li>        // 获取HttpServletRequest对象  </li>
<li>        HttpServletRequest req = ServletActionContext.getRequest();  </li>
<li>  </li>
<li>        // 获取此请求的地址  </li>
<li>        String path = req.getRequestURI();  </li>
<li>        System.out.println("path:" + path);  </li>
<li>        // 存入session，方便调用  </li>
<li>        session.put("prePage", path);  </li>
<li>  </li>
<li>        // 没有登录，将服务器提示设置成一个HttpServletRequest属性  </li>
<li>        ctx.put("tip", "您还没有登录，请输入hsing,hsu登录系统");  </li>
<li>  </li>
<li>        // 直接返回login的逻辑视图  </li>
<li>        return "login";  </li>
<li>    }  </li>
<li>}  </li>
</ol>

<pre>package com.hsinghsu.test.interceptor;

import com.opensymphony.xwork2.*;
import com.opensymphony.xwork2.interceptor.AbstractInterceptor;
import java.util.*;
import javax.servlet.http.HttpServletRequest;
import org.apache.struts2.ServletActionContext;

public class UserInterceptor extends AbstractInterceptor {

	private static final long serialVersionUID = 4956767125951165062L;

	// 拦截Action处理的拦截方法
	public String intercept(ActionInvocation invocation) throws Exception {

		// 取得请求相关的ActionContext实例
		ActionContext ctx = invocation.getInvocationContext();
		Map&lt;String, Object&gt; session = ctx.getSession();
		// 取出名为user的Session属性
		String user = (String) session.get("user");

		// 如果已经登录，放行
		if (user != null &amp;&amp; user.equals("hsing")) {
			return invocation.invoke();
		}

		// 获取HttpServletRequest对象
		HttpServletRequest req = ServletActionContext.getRequest();

		// 获取此请求的地址
		String path = req.getRequestURI();
		System.out.println("path:" + path);
		// 存入session，方便调用
		session.put("prePage", path);

		// 没有登录，将服务器提示设置成一个HttpServletRequest属性
		ctx.put("tip", "您还没有登录，请输入hsing,hsu登录系统");

		// 直接返回login的逻辑视图
		return "login";
	}
}</pre>
<p>新建登录action，LoginAction.java代码如下：</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>package com.hsinghsu.test.action;  </li>
<li>  </li>
<li>import com.opensymphony.xwork2.ActionSupport;  </li>
<li>import com.opensymphony.xwork2.ActionContext;  </li>
<li>  </li>
<li>import java.util.*;  </li>
<li>  </li>
<li>public class LoginAction extends ActionSupport {  </li>
<li>  </li>
<li>    private static final long serialVersionUID = 8013816027944871760L;  </li>
<li>    private String username;// 登录用户名  </li>
<li>    private String password;// 登录密码  </li>
<li>    private String prePage;// 登录前页面  </li>
<li>  </li>
<li>    public String execute() throws Exception {  </li>
<li>          </li>
<li>        if (null != username &amp;&amp; null != password &amp;&amp; username.equals("hsing") &amp;&amp; password.equals("hsu")) {  </li>
<li>  </li>
<li>            ActionContext ctx = ActionContext.getContext();  </li>
<li>            Map&lt;String, Object&gt; session = ctx.getSession();  </li>
<li>              </li>
<li>            //保存用户信息session  </li>
<li>            session.put("user", getUsername());  </li>
<li>  </li>
<li>            // 获取跳转到登陆界面之前的页面地址，由拦截器提供  </li>
<li>            prePage = (String) session.get("prePage");  </li>
<li>  </li>
<li>            // 清除session中的数据  </li>
<li>            session.remove("prePage");  </li>
<li>  </li>
<li>            if (null == prePage) {  </li>
<li>                return "usercenter";// 不是拦截器跳转到登陆页面的，直接访问的登陆页面  </li>
<li>            } else {  </li>
<li>                return SUCCESS;// 是拦截器跳转到登陆登录前页面  </li>
<li>            }  </li>
<li>  </li>
<li>        } else {  </li>
<li>            return INPUT;  </li>
<li>        }  </li>
<li>    }  </li>
<li>  </li>
<li>    public void setUsername(String username) {  </li>
<li>        this.username = username;  </li>
<li>    }  </li>
<li>  </li>
<li>    public String getUsername() {  </li>
<li>        return this.username;  </li>
<li>    }  </li>
<li>  </li>
<li>    public void setPassword(String password) {  </li>
<li>        this.password = password;  </li>
<li>    }  </li>
<li>  </li>
<li>    public String getPassword() {  </li>
<li>        return this.password;  </li>
<li>    }  </li>
<li>  </li>
<li>    public String getPrePage() {  </li>
<li>        return prePage;  </li>
<li>    }  </li>
<li>  </li>
<li>    public void setPrePage(String prePage) {  </li>
<li>        this.prePage = prePage;  </li>
<li>    }  </li>
<li>}  </li>
</ol>

<pre>package com.hsinghsu.test.action;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ActionContext;

import java.util.*;

public class LoginAction extends ActionSupport {

	private static final long serialVersionUID = 8013816027944871760L;
	private String username;// 登录用户名
	private String password;// 登录密码
	private String prePage;// 登录前页面

	public String execute() throws Exception {

		if (null != username &amp;&amp; null != password &amp;&amp; username.equals("hsing") &amp;&amp; password.equals("hsu")) {

			ActionContext ctx = ActionContext.getContext();
			Map&lt;String, Object&gt; session = ctx.getSession();

			//保存用户信息session
			session.put("user", getUsername());

			// 获取跳转到登陆界面之前的页面地址，由拦截器提供
			prePage = (String) session.get("prePage");

			// 清除session中的数据
			session.remove("prePage");

			if (null == prePage) {
				return "usercenter";// 不是拦截器跳转到登陆页面的，直接访问的登陆页面
			} else {
				return SUCCESS;// 是拦截器跳转到登陆登录前页面
			}

		} else {
			return INPUT;
		}
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getUsername() {
		return this.username;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getPassword() {
		return this.password;
	}

	public String getPrePage() {
		return prePage;
	}

	public void setPrePage(String prePage) {
		this.prePage = prePage;
	}
}</pre>
<p>配置拦截器与action映射关系，struts.xml代码如下：</p>
<p><strong>[html]</strong> <a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>&lt;?xml version="1.0" encoding="UTF-8"?&gt;  </li>
<li>&lt;!DOCTYPE struts PUBLIC  </li>
<li>    "-//Apache Software Foundation//DTD Struts Configuration 2.1.7//EN"  </li>
<li>    "http://struts.apache.org/dtds/struts-2.1.7.dtd"&gt;  </li>
<li>&lt;struts&gt;  </li>
<li>    &lt;constant name="struts.custom.i18n.resources" value="globalMessages" /&gt;  </li>
<li>    &lt;constant name="struts.i18n.encoding" value="UTF-8" /&gt;  </li>
<li>  </li>
<li>    &lt;package name="hsinghsu" extends="struts-default"&gt;  </li>
<li>      </li>
<li>        &lt;!-- 用户拦截器定义 --&gt;  </li>
<li>        &lt;interceptors&gt;  </li>
<li>            &lt;interceptor name="userInterceptor" class="com.hsinghsu.test.interceptor.UserInterceptor" /&gt;  </li>
<li>        &lt;/interceptors&gt;  </li>
<li>  </li>
<li>        &lt;!-- 定义全局result --&gt;  </li>
<li>        &lt;global-results&gt;  </li>
<li>            &lt;result name="login"&gt;/jsp/login.jsp&lt;/result&gt;  </li>
<li>        &lt;/global-results&gt;  </li>
<li>  </li>
<li>        &lt;action name="loginPro" class="com.hsinghsu.test.action.LoginAction"&gt;  </li>
<li>            &lt;result name="success" type="redirectAction"&gt;${prePage}&lt;/result&gt;  </li>
<li>            &lt;result name="input"&gt;/jsp/login.jsp&lt;/result&gt;  </li>
<li>            &lt;result name="usercenter"&gt;/jsp/userCenter.jsp&lt;/result&gt;  </li>
<li>        &lt;/action&gt;  </li>
<li>          </li>
<li>        &lt;action name="productList"&gt;  </li>
<li>            &lt;result name="success"&gt;/jsp/productList.jsp&lt;/result&gt;  </li>
<li>            &lt;interceptor-ref name="defaultStack" /&gt; &lt;!-- 默认拦截器 --&gt;  </li>
<li>            &lt;interceptor-ref name="userInterceptor" /&gt; &lt;!-- 应用自定义拦截器 --&gt;  </li>
<li>        &lt;/action&gt;  </li>
<li>          </li>
<li>    &lt;/package&gt;  </li>
<li>&lt;/struts&gt;  </li>
</ol>

<pre>&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;!DOCTYPE struts PUBLIC
	"-//Apache Software Foundation//DTD Struts Configuration 2.1.7//EN"
	"http://struts.apache.org/dtds/struts-2.1.7.dtd"&gt;
&lt;struts&gt;
	&lt;constant name="struts.custom.i18n.resources" value="globalMessages" /&gt;
	&lt;constant name="struts.i18n.encoding" value="UTF-8" /&gt;

	&lt;package name="hsinghsu" extends="struts-default"&gt;

		&lt;!-- 用户拦截器定义 --&gt;
		&lt;interceptors&gt;
			&lt;interceptor name="userInterceptor" class="com.hsinghsu.test.interceptor.UserInterceptor" /&gt;
		&lt;/interceptors&gt;

		&lt;!-- 定义全局result --&gt;
		&lt;global-results&gt;
			&lt;result name="login"&gt;/jsp/login.jsp&lt;/result&gt;
		&lt;/global-results&gt;

		&lt;action name="loginPro" class="com.hsinghsu.test.action.LoginAction"&gt;
			&lt;result name="success" type="redirectAction"&gt;${prePage}&lt;/result&gt;
			&lt;result name="input"&gt;/jsp/login.jsp&lt;/result&gt;
			&lt;result name="usercenter"&gt;/jsp/userCenter.jsp&lt;/result&gt;
		&lt;/action&gt;

		&lt;action name="productList"&gt;
			&lt;result name="success"&gt;/jsp/productList.jsp&lt;/result&gt;
			&lt;interceptor-ref name="defaultStack" /&gt; &lt;!-- 默认拦截器 --&gt;
			&lt;interceptor-ref name="userInterceptor" /&gt; &lt;!-- 应用自定义拦截器 --&gt;
		&lt;/action&gt;

	&lt;/package&gt;
&lt;/struts&gt;</pre>
<p>登录页面login.jsp代码如下：</p>
<p><strong>[html]</strong> <a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>&lt;%@ page contentType="text/html; charset=utf-8" language="java"  </li>
<li>    errorPage=""%&gt;  </li>
<li>&lt;%@ taglib prefix="s" uri="/struts-tags"%&gt;  </li>
<li>&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"  </li>
<li>    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;  </li>
<li>&lt;html xmlns="http://www.w3.org/1999/xhtml"&gt;  </li>
<li>&lt;head&gt;  </li>
<li>&lt;title&gt;登录页面&lt;/title&gt;  </li>
<li>&lt;/head&gt;  </li>
<li>&lt;body&gt;  </li>
<li>    &lt;h3&gt;用户登录&lt;/h3&gt;  </li>
<li>    ${tip}  </li>
<li>    &lt;s:form action="loginPro"&gt;  </li>
<li>        &lt;s:textfield name="username" label="用户名" /&gt;  </li>
<li>        &lt;s:password name="password" label="密码" /&gt;  </li>
<li>        &lt;s:submit value="登录" /&gt;  </li>
<li>    &lt;/s:form&gt;  </li>
<li>&lt;/body&gt;  </li>
<li>&lt;/html&gt;  </li>
</ol>

<pre>&lt;%@ page contentType="text/html; charset=utf-8" language="java"
	errorPage=""%&gt;
&lt;%@ taglib prefix="s" uri="/struts-tags"%&gt;
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;
&lt;html xmlns="http://www.w3.org/1999/xhtml"&gt;
&lt;head&gt;
&lt;title&gt;登录页面&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
	&lt;h3&gt;用户登录&lt;/h3&gt;
	${tip}
	&lt;s:form action="loginPro"&gt;
		&lt;s:textfield name="username" label="用户名" /&gt;
		&lt;s:password name="password" label="密码" /&gt;
		&lt;s:submit value="登录" /&gt;
	&lt;/s:form&gt;
&lt;/body&gt;
&lt;/html&gt;</pre>
<p>产品列表页面productList.jsp代码如下：</p>
<p><strong>[html]</strong> <a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>&lt;%@ page contentType="text/html; charset=utf-8" language="java"  </li>
<li>    errorPage=""%&gt;  </li>
<li>&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"  </li>
<li>    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;  </li>
<li>&lt;html xmlns="http://www.w3.org/1999/xhtml"&gt;  </li>
<li>&lt;head&gt;  </li>
<li>&lt;title&gt;产品列表&lt;/title&gt;  </li>
<li>&lt;/head&gt;  </li>
<li>&lt;body&gt;  </li>
<li>    &lt;h2&gt;水果：&lt;/h2&gt;  </li>
<li>    苹果&lt;br/&gt; 橘子&lt;br/&gt; 香蕉&lt;br/&gt;  </li>
<li>&lt;/body&gt;  </li>
<li>&lt;/html&gt;  </li>
</ol>

<pre>&lt;%@ page contentType="text/html; charset=utf-8" language="java"
	errorPage=""%&gt;
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;
&lt;html xmlns="http://www.w3.org/1999/xhtml"&gt;
&lt;head&gt;
&lt;title&gt;产品列表&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
	&lt;h2&gt;水果：&lt;/h2&gt;
	苹果&lt;br/&gt; 橘子&lt;br/&gt; 香蕉&lt;br/&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>
<p>用户中心userCenter.jsp代码如下：</p>
<p><strong>[html]</strong> <a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/xumengxing/article/details/8888435#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>&lt;%@ page contentType="text/html; charset=utf-8" language="java"  </li>
<li>    errorPage=""%&gt;  </li>
<li>&lt;%@ taglib prefix="s" uri="/struts-tags"%&gt;  </li>
<li>&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"  </li>
<li>    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;  </li>
<li>&lt;html xmlns="http://www.w3.org/1999/xhtml"&gt;  </li>
<li>&lt;head&gt;  </li>
<li>&lt;title&gt;成功页面&lt;/title&gt;  </li>
<li>&lt;/head&gt;  </li>
<li>&lt;body&gt;个人用户中心，您已经登录!  </li>
<li>&lt;/body&gt;  </li>
<li>&lt;/html&gt;  </li>
</ol>

<pre>&lt;%@ page contentType="text/html; charset=utf-8" language="java"
	errorPage=""%&gt;
&lt;%@ taglib prefix="s" uri="/struts-tags"%&gt;
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;
&lt;html xmlns="http://www.w3.org/1999/xhtml"&gt;
&lt;head&gt;
&lt;title&gt;成功页面&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;个人用户中心，您已经登录!
&lt;/body&gt;
&lt;/html&gt;</pre>
<p>验证：<br />
情形一：若用户未登录，输入http://localhost:8686/testInterceptor/productList.action<br />则系统会自动跳转到login.jsp页面，进行用户登录，登录后系统会自动跳到productList.jsp前台展现页面。<br />
情形二：若用户已登录，输入http://localhost:8686/testInterceptor/productList.action<br />则系统直接跳转到productList.jsp前台展现页面。<br />
情形三：若用户未登录，输入http://localhost:8686/testInterceptor/testInterceptor/loginPro.action<br />则系统会自动跳转到login.jsp页面，进行用户登录，登录后系统会自动跳到userCenter.jsp前台展现页面。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-06 08:40:51</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/session/" title="session">session</a>, <a href="https://www.iamivan.net/tag/html/" title="html">html</a>, <a href="https://www.iamivan.net/tag/jsp/" title="jsp">jsp</a>, <a href="https://www.iamivan.net/tag/utf-8/" title="utf-8">utf-8</a>, <a href="https://www.iamivan.net/tag/struts/" title="Struts">Struts</a>, <a href="https://www.iamivan.net/tag/login/" title="login">login</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Struts 拦截器权限控制【通过拦截器实现登录后跳转到登录前页面】的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYXVKlb.html" rel="bookmark">web jsp filter 权限控制 运行测试出现500问题 怎么解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 web jsp filter 权限控制 运行测试出现500问题 怎么解决 工程结构 index.jsp为登陆页面,UserServlet.java为针对登陆的servlet,登陆成功或失败都会跳转到show.jsp,但是有Userfilter.java的过滤.一旦登陆失败会让页面转到error.jsp. 正常是流程:进入index.jsp输入账号密码,登陆成功后进入show.jsp(测试过没问题) 错误的用例:通过控制url绕过index.jsp直接进入show.jsp(出现500错误			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKndKz.html" rel="bookmark">struts2如何使用拦截器进行用户权限控制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大多数网站会设置用户权限,如过滤非法用户,用户不登录时不能进行访问,或者设置访问的权限,如部分内容仅对VIP开放等等,这些权限的控制都可以用struts2中的拦截器来实现. 下面通过一个简单的Demo来模拟这种用户权限控制的实现流程,设定三种不同身份的用户,commen为普通用户,VIP为会员用户,还有一种admin为管理员. 先看一下Demo的整体结构: 首先搭建struts2框架的开发环境(前面博客中有介绍),环境搭建完之后又再看一看如何配置struts.xml: &lt;?xml version			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZKV4b.html" rel="bookmark">interceptor-spring中使用Interceptor拦截器，如何在拦截器中获取页面请求后台的方法的结果集？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 spring中使用Interceptor拦截器,如何在拦截器中获取页面请求后台的方法的结果集? spring中使用Interceptor拦截器,如何在拦截器中获取页面请求后台的方法的结果集? 解决方案 你可以在拦截器内获取访问的URL,自行判断 解决方案二: 获取页面请求后台的方法的结果集 什么意思?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bammgNb.html" rel="bookmark">springMVC4&lpar;16&rpar;拦截器解析与登陆拦截模拟</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在SpringMVC中,我们会经常使用到拦截器,虽然SpringAOP也能帮我们实现强大的拦截器功能,但在Web资源供给上,却没有SpringMVC来得方便快捷. 使用SpringMVC拦截器的核心应用场景是根据我们的实际需求,个性化定制拦截器,再对特定url进行拦截处理. 而自定义拦截器,首先需要我们实现HandlerInterceptor拦截器接口,下面是它的定义: package org.springframework.web.servlet; public interface Handl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkeAaob.html" rel="bookmark">spring 拦截方法中如何获取拦截器中变量的值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 spring 拦截方法中如何获取拦截器中变量的值 想在拦截方法中获取拦截器中变量的值,如何用代码实现?求指教.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGZ1y2p.html" rel="bookmark">spring mvc-SpringMvc拦截器配置怎么配置拦截一个网站</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 SpringMvc拦截器配置怎么配置拦截一个网站 我想拦截一个网址,比如页面的地址是www.XXXX.com.配置文件怎么配? 不拦截全部,只拦截单个网址的那种 解决方案 在controller层中来配置拦截的URL @RequestMapping(&quot;configSettRule&quot;) public class SettRuleController extends BaseController{ @Resource private SettRuleManager settRul			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baBKm2M.html" rel="bookmark">Springnvc框架中的拦截器如何配置可以拦截html页面的请求&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Springnvc框架中的拦截器如何配置可以拦截html页面的请求? Springnvc框架中的拦截器如何配置可以拦截html页面的请求? 解决方案 SpringMVC及拦截器基本配置:http://se7en8974.iteye.com/blog/826670 springMVC 拦截器简单配置:http://blog.csdn.net/lqx1988221/article/details/36420887			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLO4o5M.html" rel="bookmark">Acegi &plus; Spring &plus; Hibernate &plus; Struts 2搭建基于角色的权限控制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				安全永远是WEB应用系统必须面对的头等大事, 也是最头疼的事, 其实安全系统就只包括两个问题: 认证和授权. 以前做些网站系统, 安全检测逻辑都在放在须要安全控制的代码前面, 这样做有很多不好的地方, 重复多次的编码就不用说了, 代码移植性, 重用性都得不到体现, 安全检测逻辑要永远和业务逻辑放在一起. 那么, 能不能够在进入方法前就调用一些安全检测? 其实Spring AOP就是这个思想, 那么又如何实现安全检测呢? Spring Acegi Security 框架就是做这个事情. 本文主要是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2P06Vp.html" rel="bookmark">利用OpenCV和MFC对话框建设一个有滑动条控制的播放器--转</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(一)问题的提出: OpenCV有一个很简单的播放视频文件并加载滑动条的程序,但是如何用MFC对话框来创建一个有滑动条控制的播放器呢,网络上四处搜索都没有代码可以参考,下的都是些骗子链接文件,很过分,一点参考价值都没有,怎么办? (二)解决的思路: 1.自己进行研究,不指望网络有现成的馅饼,因为那里多了去的陷阱,很可恶. 2.要解决的关键问题是slider滑动条控件如何与视频播放实时结合在一起:   ①主窗体的OnHScroll()响应函数负责响应slider滑动条的变化,这样就轻松搞定slid			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boO56b.html" rel="bookmark" class="title">ajax如何从服务器端返回xml数据</a>
					<div>
						原始的Ajax:直接使用XmlHttpRequest 如上所述,Ajax的核心是JavaScript对象XmlHttpRequest.下面的示例文章评价系统将带您熟悉Ajax的底层基本知识:http: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQk78p.html" rel="bookmark" class="title">CSS3系列教程</a>
					<div>
						使用CSS3 HSL声明同样是用来设置颜色的.下一个呢? HSLA? 是的,这个和RGBA的效果是一样的. HSL声明使用色调Hue(H).饱和度Saturation(s)和亮度Lightness(L ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKOnLb.html" rel="bookmark" class="title">增加外链的八个方法</a>
					<div>
						外链的权重越来越被重视了,之前百度看重内容的质量,但是现在通过一些站点的测试发现百度加重了外链的权重了,外链在百度的心目中也从丫鬟变成姨太了!外链故之重要,但要注重外链的质量和增加的频率.以下是增加外 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpdqvxz.html" rel="bookmark" class="title">PHP界的大事：zend已经可以破解</a>
					<div>
						10月4日,国内有一家名为清风工作室的网站推出一款名为deZender的软件,据他们说&quot;deZender可以反编译被zend编译过的所有 PHP代码,由deZender产生的PHP源代码同原 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Rw4jp.html" rel="bookmark" class="title">一个完善的ODBC数据库程序</a>
					<div>
						大家知道用VC开发数据库程序,一般有两种选择:ODBC或ADO.ODBC出现的较早,用的人也多.ADO是微软正大力支持和发展的技术,致力于学习VC的程序员应该现在就学习这种技术. 在这个例字中我还是采 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRRvlp.html" rel="bookmark" class="title">win10预览版10041无斯巴达浏览器 IE浏览器Edge渲染引擎更新</a>
					<div>
						  3月19日消息,微软在官方IE博客中不仅确认了斯巴达浏览器预览版将包含在下个Win10版本中,而且还列出了本次Build 10041版本中IE浏览器Edge渲染引擎更新的细节.本次更新的引擎功能是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr358Wp.html" rel="bookmark" class="title">U盘代替光驱 一键安装系统成主流</a>
					<div>
						光驱已经渐渐淡出计算机舞台,但是由于移动硬盘的发展,我们还是照样可以听歌,看影碟.然而,没了光驱,我们的计算机系统该如何安装,计算机的维护又该如何进行?带着这个疑问,一项新技术诞生了,随着这项新技术的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8onOb.html" rel="bookmark" class="title">Win7 64位系统下u盘启动盘制作过程中常见问题分析</a>
					<div>
						  1.启动成功后出现死机故障 PE要加载的ISO文件不能太大,一般不超过50MB.如果计算机配置低,运行速度慢,当加载时间过长时,内存就会出现冗余,就会出现死机的现象了. 2.制作工具的选择 制作工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr38dOp.html" rel="bookmark" class="title">winXP系统下添加&sol;删除程序面板中显示空白问题的解决方法</a>
					<div>
						  1.首先,咱们单击打开winXP电脑的开始菜单,然后从开始菜单中选择进入到运行窗口中,在打开的运行窗口中,咱们输入cmd并单击回车,这样就可以打开winXP系统的命令提示符窗口了. 2.在打开的命 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8XJkb.html" rel="bookmark" class="title">ERROR 1045 &lpar;28000&rpar;&colon; Access denied for user &amp;amp&semi;&num;39&semi;root&amp;amp&semi;&num;39&semi;&commat;&amp;amp&semi;&num;39&semi;localhost&amp;amp&semi;&num;39&semi; &lpar;using password&colon; YES&rpar;</a>
					<div>
						ERROR 1045 (28000): Access denied for user 'root'@'localhost' (using password: YES) root@mysql ~]# m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm63Lwz.html" rel="bookmark" class="title">连接-cocos2dx-3&period;x如何实现外网联机？？？用sock大概如何实现？</a>
					<div>
						问题描述 cocos2dx-3.x如何实现外网联机???用sock大概如何实现? 我现在就是想实现多人联机游戏,比如多人异地可以搜索到对方进行连接,请问这是通过怎样来实现的?用socket的大概实现原 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NoGrM.html" rel="bookmark" class="title">5&period;20PM 名师点拨ASP&period;NET实战进阶</a>
					<div>
						问题描述 访谈时间:2008年5月20日(周二)下午2:00--3:00访谈目的:越来越多的人开始认识和了解ASP.NET技术,但熟悉并不等同于掌握,对于怎样去驾驭它很大一部分人还存在一定的疑问和行动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN79XJp.html" rel="bookmark" class="title">Scalaz（37）－ Free ：实践－DB Transaction free style</a>
					<div>
						 我一直在不断的提示大家:FP就是Monadic Programming,是一种特殊的编程风格.在我们熟悉的数据库编程领域能不能实现FP风格呢?我们先设计一些示范例子来分析一下惯用的数据库编程过程:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6wk5z.html" rel="bookmark" class="title">discuz&excl;-客户想做一个比较有个性的论坛社区，而用discuz与dedecms做的样例又不太满意，该怎么办？</a>
					<div>
						问题描述 客户想做一个比较有个性的论坛社区,而用discuz与dedecms做的样例又不太满意,该怎么办? 因为可能是前期沟通的问题,订单是接下来,客户也负款了,而技术人员招进来后, 说客户要求是无法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NgxjM.html" rel="bookmark" class="title">国务院发文取消BBS等电子公告服务审批备案</a>
					<div>
						7月10日消息,国务院7月9日下发&lt;关于第五批取消和下放管理层级http://www.aliyun.com/zixun/aggregation/30887.html&quot;&gt;行政审批项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2Lreb.html" rel="bookmark" class="title">Windows Azure使用VS 2010的云应用开发过程</a>
					<div>
						原文 Windows Azure使用VS 2010的云应用开发过程 作为技术人员,如果在2010还不知道云计算,那么你已经&quot;OUT&quot;了:作为Visual Studio平台的使用者, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZR1rp.html" rel="bookmark" class="title">tabs-标签图标为什么不能显示？</a>
					<div>
						问题描述 标签图标为什么不能显示? 我想做一个简单的标签应用,这个标签应用中有两个选项卡.现在的问题是当我在标签应用中加入下面的代码,只显示文本,没有图标.如果我给文本加 &quot;&quot;,图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYxmWp.html" rel="bookmark" class="title">AIX下安装Hadoop</a>
					<div>
						今天在测试通过JAVA操作远程的AIX主机,突然想到之前在Linux上安装过Hadoop,但是没有在Aix上做过尝试,很想知道Hadoop在Aix下的安装是否会有什么不同,于是心血来潮的安装了一遍,过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd8j4b.html" rel="bookmark" class="title">支持国货当自强KV2008不错</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 这款软件在早些时候公测就得 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlL2mVM.html" rel="bookmark" class="title">index-Index没有返回值是怎麽回事，求指导</a>
					<div>
						问题描述 Index没有返回值是怎麽回事,求指导 #include #include #include #define MAXSTLEN 234 typedef char SString[MAXSTL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXjmBb.html" rel="bookmark" class="title">拍客网站运营过程中如何利用软文谋取更多流量</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 淘宝拍拍客是指从事于淘宝网.拍拍网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnWg6M.html" rel="bookmark" class="title">社会化媒体营销到底步入一个怎样的困境</a>
					<div>
						近些日子,对于社会化媒体营销,新浪微博上出现了一些争论,这些争论从质疑一些微博营销公司(或者传媒公司?公关公司?我也搞不清)中的个人行为开始,继而争议蔓延到某些公司行为,最后议论声直接指向整个社会化媒 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWW4rmM.html" rel="bookmark" class="title">网络-关于多级路由组播问题</a>
					<div>
						问题描述 关于多级路由组播问题 请教问题,请高手不吝赐教 在一个局域网中有两个路由器Rouer-A和Router-B(假设都不支持组播功能),两个路由器下面分别有两台主机PC-A和PC-B,PC-A和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQ6JQp.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;全民公敌&rdquo;马化腾：如果我们不前进 就会被取代</a>
					<div>
						2011年过去了,互联网公司老板们的问题单中又多了一条:&quot;马化腾究竟是敌是友?&quot; 而在这之前,外界送给马化腾的雅号是&quot;模仿大师&quot;,那句经典的&quot;一直在模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJvARp.html" rel="bookmark" class="title">深圳中软实习始末</a>
					<div>
						7月中旬,29个小时的火车,给我带到这么一个地方 岗头发展大厦十楼. 同事中确实不少极品,大家互相介绍的时候,有人 这么说他是怎么来深圳的:我以为深圳就在我们学校边上 所以我就果断的签约了.我以为大学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBWeDz.html" rel="bookmark" class="title">多名用户建议戴尔推出预装Linux系统的PC机</a>
					<div>
						免费软件基金会(FSF)日前表示,微软新一代操作系统Windows Vista阻碍了消费者购买新硬件.因此,全球主要的PC厂商应该封杀Vista系统. 据美国&lt;信息周刊&gt;网站报道,FSF常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8R8Ab.html" rel="bookmark" class="title">php preg&lowbar;match获取新浪新闻代码</a>
					<div>
						&lt;html&gt;     &lt;head&gt;         &lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;tex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZQ50z.html" rel="bookmark" class="title">字段名的显示问题 急（C&num;） 在线等</a>
					<div>
						问题描述 大家好,我在用Gridview的时候,从数据库里面取出数据进行绑定.有3个表,表一:学生ID,学生姓名:表二:课程ID,课程名:表三:学生ID,课程ID,成绩:要在GridView里面成如下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrgrvp.html" rel="bookmark" class="title">对象-android 医院语音叫号  求大神指点</a>
					<div>
						问题描述 android 医院语音叫号 求大神指点 想实现一句维语,一句汉语,一直循环,但是逻辑这里卡住了.求大神指点迷津 下面有源码 package com.zkr.voice; import ja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXLX0z.html" rel="bookmark" class="title">淘宝微信互相屏蔽影响了谁</a>
					<div>
						一.什么样的应用被影响了 1.曾被官方支持的最典型的莫过于口袋通了,官方地址http://koudaitong.com/现在显示 由于接口变更,暂停接入.  2.在淘宝卖家服务上出售的应用 阿里在声明 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
